import { Command } from "discord-akairo";
import { Message } from "discord.js";
import { cancelString } from "../../config/Constants";
import { Appeal } from "../../entity/Appeal";
import { infoEmbed } from "../Util";

class AppealCommand extends Command {
  constructor() {
    super("appeal", {
      category: "Review",
      aliases: ["Appeal"],
      description: "<appeal>",
      clientPermissions: ["CREATE_INSTANT_INVITE", "BAN_MEMBERS"],
      channel: "guild",
      args: [
        {
          id: "appeal",
          type: "appeal",
          prompt: {
            start: () => infoEmbed("The appeal ID:").setFooter(cancelString),
          },
        },
      ],
    });
  }

  async exec(message: Message, args: { appeal: Appeal }) {
    const { appeal } = args;
    message.reply(appeal.embed(false));
  }
}

export default AppealCommand;
