import { Category, Command } from "discord-akairo";
import { Message } from "discord.js";
import { infoEmbed } from "../Util";

class Help extends Command {
  constructor() {
    super("help", {
      category: "Utility",
      aliases: ["Help"],
    });
  }

  exec(message: Message) {
    const embed = infoEmbed("Help menu").setDescription(
      "Here is a list of available commands."
    );

    this.handler.categories.forEach((c: Category<any, any>, k: string) => {
      const value = c
        .map((cmd: Command) => cmd.aliases[0] + " " + (cmd.description || ""))
        .join("\n");

      embed.addField(k, "```fix\n" + value + "```");
    });

    message.reply(embed);
  }
}

export default Help;
