import { Command, Listener } from "discord-akairo";
import { Message } from "discord.js";
import Bot from "../Bot";
import { errorEmbed } from "../Util";

class CommandBlockedListener extends Listener {
  constructor() {
    super("commandBlocked", {
      emitter: "commandHandler",
      event: "commandBlocked",
    });
  }

  exec(message: Message, command: Command, reason: string) {
    const prefix = Bot.config.bot.prefix;
    if (reason === "unregistered")
      return message.reply(
        errorEmbed("You must setup the guild first.").setDescription(
          `Try ${prefix}setup.`
        )
      );

    if (reason === "permissions")
      return message.reply(
        errorEmbed("You do not have access to this command.")
      );

    if (reason === "no guild")
      return message.reply(errorEmbed("You cannot run commands in DMs."));

    if (reason === "already setup")
      return message.reply(
        errorEmbed("This guild is already setup").setDescription(
          "To update configuration, use other commands."
        )
      );
  }
}

export default CommandBlockedListener;
