import { Command, Listener } from "discord-akairo"
import { Message } from "discord.js"
import { errorEmbed } from "../Util"

class MissingPermissions extends Listener {
    constructor() {
        super('missingPermissions', {
            emitter: 'commandHandler',
            event: 'missingPermissions'
        });
    }

    exec(message: Message, command: Command, reason: string, missing: Array<string>) {
        if (reason === "user") return message.reply(errorEmbed("Missing permissions."))
        if (reason === "client") {
            const embed = errorEmbed("The bot is missing required permissions")
                .setDescription("Permisisons required: `" + missing.join(", ") + "`.")
            return message.reply(embed)
        }
    }
}

export default MissingPermissions
