import { Listener } from "discord-akairo";
import { TextChannel } from "discord.js";
import { Appeal } from "../../entity/Appeal";
import { Guild } from "../../entity/Guild";

class NewAppeal extends Listener {
  constructor() {
    super("newAppealHandler", {
      emitter: "appealHandler",
      event: "newAppeal",
    });
  }

  async exec(
    guild: Guild,
    appeal: Appeal,
    success: () => {},
    fail: (msg: string) => {}
  ) {
    const g = await this.client.guilds.fetch(guild.guild).catch(() => null);
    if (!g) {
      return fail("Could not submit appeal. Guild not found.");
    }

    const ban = await g.fetchBan(appeal.userID).catch(() => null);
    if (!ban) {
      return fail("Could not submit appeal. No ban found for user.");
    }

    const channel = await this.client.channels
      .fetch(guild.channel)
      .catch(() => null);
    if (!channel?.isText()) {
      return fail("Could not submit appeal. Guild configuration invalid.");
    }

    success();

    const embed = appeal.embed(true)
    const msg = await (channel as TextChannel).send(embed);
    appeal.message = msg.id;
    await appeal.save();

    msg.edit(embed.setFooter("Appeal ID: " + appeal.id));
    msg.react("✅");
    // msg.react("❔");
    msg.react("❌");
  }
}

export default NewAppeal;
